unit tateris;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, DXDraws, Menus, DXInput, DXClass, DXSounds;

type
  TFAnwendung = class(TForm)
    DXDraw1: TDXDraw;
    Label1: TLabel;
    lScore: TLabel;
    DXImageList1: TDXImageList;
    DXEingabe: TDXInput;
    MyMenu: TMainMenu;
    MMDatei: TMenuItem;
    MMClose: TMenuItem;
    DXMainTimer: TDXTimer;
    DXSound1: TDXSound;
    DXWaveList: TDXWaveList;
    DXDVorschau: TDXDraw;
    MMNew: TMenuItem;
    MMHelp: TMenuItem;
    MMPause: TMenuItem;
    Label2: TLabel;
    lLines: TLabel;
    MMSplash: TMenuItem;
    MMHilfe: TMenuItem;

    procedure MMCloseClick(Sender: TObject);
    procedure ZeichneFeld;
    procedure FormCreate(Sender: TObject);
    procedure BlockRunter;
    procedure DXMainTimerTimer(Sender: TObject; LagCount: Integer);
    procedure BlockFest;
    function CheckBlock:Boolean;
    procedure NeuerBlock;
    function KillLines:Boolean;
    procedure RunterSetzen;
    procedure NachLinks;
    procedure NachRechts;
    function DarfRechts:Boolean;
    function DarfLinks:Boolean;
    procedure RotateRechts;
    procedure RotateLinks;
    procedure HauRein;
    procedure Runterdamit;
    procedure MMNewClick(Sender: TObject);
    procedure MMPauseClick(Sender: TObject);
    procedure MMSplashClick(Sender: TObject);
    procedure MMHilfeClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FAnwendung: TFAnwendung;
  spielfeld : Array[1..8,-4..20] of Integer;
  vorschau : array[1..4,1..4] of Integer;
  score, lines : integer;
  welcherblock, aktuell : integer;
  x,y : integer;
  timer : longint;

implementation

uses splash;

{$R *.DFM}

procedure TFAnwendung.RotateRechts;
var i, j, hilf, z : integer;
    gehtdas : boolean;
    ineu : array[1..4] of Integer;
    jneu : array[1..4] of Integer;
    ialt : array[1..4] of Integer;
    jalt : array[1..4] of Integer;
begin

 z := 0;
 gehtdas := true;

 if NOT(aktuell = 1) then
 begin
  for i := 20 downto -4 do
  begin
   for j := 8 downto 1 do
    begin
     if (spielfeld[j,i] = 1) then
     begin
      inc(z);

      jalt[z] := j;
      ialt[z] := i;

      spielfeld[j,i] := 0;
      jneu[z] := j - x;
      ineu[z] := i - y;

      hilf := ineu[z];
      ineu[z] := jneu[z];
      jneu[z] := -hilf;

      jneu[z] := jneu[z] + x;
      ineu[z] := ineu[z] + y;
     end;
    end;
  end;

  for i := 1 to z do
   begin
    if (ineu[i] > 20) OR (jneu[i] > 8) OR (jneu[i] < 1)
        OR (spielfeld[jneu[i],ineu[i]] = 2) then
     gehtdas := false;
   end;

  if gehtdas = true then
   begin
    for i := 1 to z do
     spielfeld[jneu[i],ineu[i]] := 1;
   end
  else
   begin
    for i := 1 to z do
     spielfeld[jalt[i],ialt[i]] := 1;
   end


 end;

end;

procedure TFAnwendung.RotateLinks;
var i, j, hilf, z : integer;
    gehtdas : boolean;
    ineu : array[1..4] of Integer;
    jneu : array[1..4] of Integer;
    ialt : array[1..4] of Integer;
    jalt : array[1..4] of Integer;
begin

 z := 0;
 gehtdas := true;

 if NOT(aktuell = 1) then
 begin
  for i := 20 downto -4 do
  begin
   for j := 8 downto 1 do
    begin
     if (spielfeld[j,i] = 1) then
     begin
      inc(z);

      jalt[z] := j;
      ialt[z] := i;

      spielfeld[j,i] := 0;
      jneu[z] := j - x;
      ineu[z] := i - y;

      hilf := ineu[z];
      ineu[z] := -jneu[z];
      jneu[z] := hilf;

      jneu[z] := jneu[z] + x;
      ineu[z] := ineu[z] + y;
     end;
    end;
  end;

  for i := 1 to z do
   begin
    if (ineu[i] > 20) OR (jneu[i] > 8) OR (jneu[i] < 1)
        OR (spielfeld[jneu[i],ineu[i]] = 2) then
     gehtdas := false;
   end;

  if gehtdas = true then
   begin
    for i := 1 to z do
     spielfeld[jneu[i],ineu[i]] := 1;
   end
  else
   begin
    for i := 1 to z do
     spielfeld[jalt[i],ialt[i]] := 1;
   end

 end;

end;

procedure TFAnwendung.RunterDamit;
begin
  while(Checkblock = true) do
   BlockRunter;
end;

function TFAnwendung.DarfRechts:Boolean;
var i, j : Integer;
    okay : boolean;
begin
 okay := true;
 for i := -4 to 20 do
  begin
   if spielfeld[8,i] = 1 then
    okay := false;
  end;

 if okay = true then
  begin
   for i := 20 downto -4 do
    begin
     for j := 7 downto 1 do
      begin
       if (spielfeld[j,i] = 1) AND (spielfeld[j+1,i] = 2) then
        okay := false;
      end;
    end;
  end;

 DarfRechts := okay;

end;

function TFAnwendung.DarfLinks:Boolean;
var i,j : Integer;
    okay : boolean;
begin
 okay := true;
 for i := -4 to 20 do begin
  if spielfeld[1,i] = 1 then
   okay := false;
 end;

 if okay = true then
  begin
   for i := 20 downto -4 do
    begin
     for j := 8 downto 2 do
      begin
       if (spielfeld[j,i] = 1) AND (spielfeld[j-1,i] = 2) then
        okay := false;
      end;
    end;
  end;

 DarfLinks := okay;
end;

procedure TFAnwendung.NachRechts;
var i,j : integer;
begin
 if DarfRechts = true then
 begin
 for i := -4 to 20 do
  begin
   for j := 8 downto 1 do
    begin
     if (spielfeld[j,i] = 1) then
      begin
       spielfeld[j+1,i] := 1;
       spielfeld[j,i] := 0;
      end;
    end;
  end;
 x := x + 1;
 end;
end;

procedure TFAnwendung.NachLinks;
var i,j : integer;
begin

 if DarfLinks = true then
 begin
 for i := -4 to 20 do
  begin
   for j := 1 to 8 do
    begin
     if (spielfeld[j,i] = 1) then
      begin
       spielfeld[j-1,i] := 1;
       spielfeld[j,i] := 0;
      end;
    end;
  end;
 x := x - 1;
 end;
end;

function TFAnwendung.CheckBlock : boolean;
var i,j : integer;
    help : boolean;
begin
  help := true;
  for i := 20 downto 0 do           { Zeilen 20 - 1 }
  begin
   for j := 1 to 8 do           { Spalten 8 - 1 }
    begin
    if (spielfeld[j,i] = 1) then
     begin
      if ((i = 0) AND (spielfeld[j,i+1] = (2))) AND (help = true) then
       begin
        DXMainTimer.Enabled := false;
        DXImageList1.Items[4].draw(DXDraw1.Surface,0,160, 0);
        DXDraw1.Flip;
        DXWaveList.Items[1].Play(False);
        help := false;
        CheckBlock := false;
       end
      else if ((i = 20) OR (spielfeld[j,i+1] = (2))) then
       begin
        BlockFest;
        KillLines;
        HauRein;
        score := score + 100;
        CheckBlock := false
       end
      else
       CheckBlock := true;
     end;

    end;
  end;

end;

procedure TFAnwendung.ZeichneFeld;
var i,j : integer;
begin

  if not DXDraw1.CanDraw then     { wenn nicht gezeichnet werden kann, beenden }
    Exit;

  DXDraw1.Surface.Fill(5);
  DXDVorschau.Surface.Fill(5);

  for i := 1 to 20 do           { Zeilen 1 - 20 }
  begin
   for j := 1 to 8 do           { Spalten 1 - 8 }
    begin
      DXImageList1.Items[spielfeld[j,i]].draw(DXDraw1.Surface,(j-1) * 16, (i-1) * 16, 0);
    end;
  end;

  for i := 1 to 4 do
   begin
    for j := 1 to 4 do
     DXImageList1.Items[vorschau[j,i]].draw(DXDVorschau.Surface,(j-1) * 16, (i-1) * 16, 0);
   end;
  DXDraw1.Flip;
  DXDVorschau.Flip;

end;

procedure TFAnwendung.BlockRunter;
var i,j : integer;
begin

  for i := 20 downto -4 do           { Zeilen 20 - 1 }
  begin
   for j := 8 downto 1 do           { Spalten 8 - 1 }
    begin
      if (spielfeld[j,i] = 1) AND (i = 20) then
       exit;

      if (spielfeld[j,i] = 1) AND (spielfeld[j,i+1] <> 2) then
       begin
        spielfeld[j,i+1] := spielfeld[j,i];
        spielfeld[j,i] := 0;
       end;
    end;
  end;
  y := y + 1;
end;

procedure TFAnwendung.BlockFest;
var i,j : integer;
begin

  for i := 1 to 20 do           { Zeilen 1 - 20 }
  begin
   for j := 1 to 8 do           { Spalten 1 - 8 }
    begin
      if spielfeld[j,i] = 1 then
      begin
       spielfeld[j,i] := 2;
      end;
    end;
  end;

end;

procedure TFAnwendung.NeuerBlock;
var i, j : integer;
begin

  for i := 1 to 4 do
  begin
   for j := 1 to 4 do
    begin
      vorschau[j,i] := 0;
    end;
  end;

 welcherblock := random(7) + 1;
 case welcherblock of
 1: begin                       { OO }
     vorschau[2,2] := 1;      { 00 }
     vorschau[2,3] := 1;
     vorschau[3,3] := 1;
     vorschau[3,2] := 1;
    end;
 2: begin
     vorschau[2,1] := 1;     { O }
     vorschau[2,2] := 1;     { O }
     vorschau[2,3] := 1;     { O }
     vorschau[2,4] := 1;     { O }
    end;
 3: begin
     vorschau[2,2] := 1;
     vorschau[2,3] := 1;
     vorschau[2,4] := 1;
     vorschau[3,2] := 1;
    end;
 4: begin
     vorschau[2,2] := 1;
     vorschau[2,3] := 1;
     vorschau[3,3] := 1;
     vorschau[3,4] := 1;
    end;
 5: begin
     vorschau[2,4] := 1;
     vorschau[2,3] := 1;
     vorschau[3,3] := 1;
     vorschau[3,2] := 1;
    end;
 6: begin
     vorschau[2,2] := 1;
     vorschau[3,2] := 1;
     vorschau[3,3] := 1;
     vorschau[3,4] := 1;
    end;
 7: begin
     vorschau[1,3] := 1;
     vorschau[2,2] := 1;
     vorschau[2,3] := 1;
     vorschau[3,3] := 1;
    end;
end;
end;

procedure TFAnwendung.HauRein;
begin
 aktuell := welcherblock;
 case (welcherblock) of
 1: begin                       { OO }
     spielfeld[4,-1] := 1;      { 00 }
     spielfeld[5,-1] := 1;
     spielfeld[4,-2] := 1;
     spielfeld[5,-2] := 1;
     x := 4; y := -2;
    end;
 2: begin
     spielfeld[4,-4] := 1;     { O }
     spielfeld[4,-3] := 1;     { O }
     spielfeld[4,-2] := 1;     { O }
     spielfeld[4,-1] := 1;     { O }
     x := 4; y := -3;
    end;
 3: begin
     spielfeld[4,-1] := 1;
     spielfeld[4,-2] := 1;
     spielfeld[4,-3] := 1;
     spielfeld[5,-3] := 1;
     x := 5; y := -2;
    end;
 4: begin
     spielfeld[5,-1] := 1;
     spielfeld[5,-2] := 1;
     spielfeld[4,-2] := 1;
     spielfeld[4,-3] := 1;
     x := 5; y := -2;
    end;
 5: begin
     spielfeld[5,-3] := 1;
     spielfeld[5,-2] := 1;
     spielfeld[4,-1] := 1;
     spielfeld[4,-2] := 1;
     x := 5; y := -2;
    end;
 6: begin
     spielfeld[5,-1] := 1;
     spielfeld[5,-2] := 1;
     spielfeld[5,-3] := 1;
     spielfeld[4,-3] := 1;
     x := 4; y := -2;
    end;
 7: begin
     spielfeld[5,-1] := 1;
     spielfeld[4,-1] := 1;
     spielfeld[3,-1] := 1;
     spielfeld[4,-2] := 1;
     x := 4; y := -1;
    end;
 end;
 NeuerBlock;
end;

function TFAnwendung.KillLines : Boolean;
var i,j,z, pluspunkt : integer;
begin
  z := 0;
  pluspunkt := 0;
  for i := 20 downto 1 do           { Zeilen 20 - 1 }
  begin
   if (spielfeld[1,i] = 2) AND (spielfeld[2,i] = 2) AND
      (spielfeld[3,i] = 2) AND (spielfeld[4,i] = 2) AND
      (spielfeld[5,i] = 2) AND (spielfeld[6,i] = 2) AND
      (spielfeld[7,i] = 2) AND (spielfeld[8,i] = 2) then
    begin
     for j := 1 to 8 do
      spielfeld[j,i] := 3;
      z := z + 1;
    end;

  end;
  ZeichneFeld;

  if z > 0 then
   begin
    DXWaveList.Items[0].Play(False);
    sleep(500);
   end;

  for i := 1 to z do
   begin
    RunterSetzen;
    inc(pluspunkt);
    inc(lines);
   end;

  score := score + (800 * pluspunkt * pluspunkt);
  KillLines := true;
end;

procedure TFAnwendung.RunterSetzen;
var i, j, i2 : integer;
begin
 for i := 20 downto 1 do           { Zeilen 20 - 1 }
  begin
   if (spielfeld[1,i] = 3) AND (spielfeld[2,i] = 3) AND
      (spielfeld[3,i] = 3) AND (spielfeld[4,i] = 3) AND
      (spielfeld[5,i] = 3) AND (spielfeld[6,i] = 3) AND
      (spielfeld[7,i] = 3) AND (spielfeld[8,i] = 3) then
   begin { of if }
    for i2 := i downto 2 do
     begin
      for j := 1 to 8 do
       begin
        spielfeld[j,i2] := spielfeld[j,i2-1];
       end;
     end;
   end; { of if }
 end;
 DXDraw1.Surface.Fill(0);
 ZeichneFeld;
end;

procedure TFAnwendung.MMCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFAnwendung.FormCreate(Sender: TObject);
begin
  DXMainTimer.Enabled := false;
  timer := 3;
  randomize;
end;

procedure TFAnwendung.DXMainTimerTimer(Sender: TObject; LagCount: Integer);
begin
 ZeichneFeld;
 lLines.Caption := IntToStr(lines);
 lScore.Caption := IntToStr(score);

 DXEingabe.Update;

 If isLeft in DXEingabe.States Then
  NachLinks;

 If isRight in DXEingabe.States Then
  NachRechts;

 If isUp in DXEingabe.States Then
  begin
   DXMainTimer.Enabled := false;
   RotateRechts;
   DXMainTimer.Enabled := true;
  end;

 If isDown in DXEingabe.States Then
  begin
   DXMainTimer.Enabled := false;
   RotateLinks;
   DXMainTimer.Enabled := true;
  end;

 If isButton1 in DXEingabe.States Then
  begin
   DXMainTimer.Enabled := false;
   RunterDamit;
   DXMainTimer.Enabled := true;
  end;

 if (timer MOD 3) = 0 then
 begin
  CheckBlock;
  BlockRunter;
 end;

 timer := timer + 1;

 if ((timer MOD 420) = 0) AND (DXMainTimer.Interval > 13) then
  DXMainTimer.Interval := DXMainTimer.Interval - 4;

 if timer = 100000 then
  timer := 1;
end;

procedure TFAnwendung.MMNewClick(Sender: TObject);
var i,j : integer;
begin
 for i := 20 downto -4 do
  begin
   for j := 8 downto 1 do
    begin
     spielfeld[j,i] := 0;
    end;
  end;

 for i := 4 downto 1 do
  begin
   for j := 4 downto 1 do
    begin
      vorschau[j,i] := 0;
    end;
  end;

 lines := 0;
 score := 0;
 timer := 3;
 DXMainTimer.Interval := 60;
 DXMainTimer.Enabled := true;
 DXWaveList.Items[2].Play(False);
 
 NeuerBlock;
 Haurein;

end;

procedure TFAnwendung.MMPauseClick(Sender: TObject);
begin
  DXMainTimer.Enabled := false;
  ShowMessage('Weiterspielen?');
  DXMainTimer.Enabled := true;
end;

procedure TFAnwendung.MMSplashClick(Sender: TObject);
begin
 FSplash.Show;
end;

procedure TFAnwendung.MMHilfeClick(Sender: TObject);
begin
  DXMainTimer.Enabled := false;
  ShowMessage('Tasten:' + #13 + #13 +
              'links: Pfeiltaste links oder R' + #13 +
              'rechts: Pfeiltaste rechts oder T' + #13 +
              'links drehen: Pfeiltaste unten oder O' + #13 +
              'rechts drehen: Pfeiltaste oben oder P' + #13 +
              'fallen lassen: Space oder K' + #13 +
              'Pause: F5');
  DXMainTimer.Enabled := true;
end;

end.

{  for i := 20 downto 1 do
  begin
   for j := 8 downto 1 do
    begin

    end;
  end; }
